# -*- coke -*-

# sp=ebx, fp=esi

start	=  insn*

insn    = 'label .:l                   `"L\#l:\n"
        | 'save                        `"        subl    $4, %ebx\n"
                                       `"        movl    %eax, (%ebx)\n"
        | 'long .:n                    `"        .data\n"
                                       `"_V_\$n: .long 0\n"
                                       `"        .text\n"
        | 'load-long  .:l              `"        movl    $\#l, %eax\n"
        | 'load-arg   .:n ->`(* 4 n):n `"        movl    (\#n)(%esi), %eax\n"
        | 'load-var   .:n              `"        movl    _V_\$n, %eax\n"
        | 'load-label .:n              `"        movl    $L\#n, %eax\n"
        | 'store-var  .:n              `"        movl    %eax, _V_\$n\n"
        | 'add                         `"        addl    (%ebx), %eax\n"
                                       `"        addl    $4, %ebx\n"
        | 'sub                         `"        subl    (%ebx), %eax\n"
                                       `"        addl    $4, %ebx\n"
        | 'less                        `"        cmpl    (%ebx), %eax\n"
                                       `"        setl    %al\n"
                                       `"        movzbl  %al, %eax\n"
                                       `"        addl    $4, %ebx\n"
        | 'branch-false .:l            `"        cmpl    $0, %eax\n"
                                       `"        je      L\#l\n"
        | 'branch .:l                  `"        jmp     L\#l\n"
        | 'call   .:n ->`(* 4 n):n     `"        call    *%eax\n"
                                       `"        addl    $\#n, %ebx\n"
        | 'enter                       `"        popl    %ecx\n"
                                       `"        movl    %ecx, -4(%ebx)\n"
                                       `"        movl    %esi, -8(%ebx)\n"
                                       `"        movl    %ebx, %esi\n"
                                       `"        subl    $8, %ebx\n"
        | 'leave                       `"        movl    %esi, %ebx\n"
                                       `"        movl    -8(%ebx), %esi\n"
                                       `"        pushl   -4(%ebx)\n"
                                       `"        ret\n"

# startup: transfer from C linkage to internal linkage

        | 'main                        `"        .globl  \${_PREFIX}main\n"
                                       `"\${_PREFIX}main:\n"
                                       `"        leal    4(%esp), %ecx\n"
                                       `"        andl    $-16, %esp\n"
                                       `"        pushl   -4(%ecx)\n"
                                       `"        pushl   %ebp\n"
                                       `"        movl    %esp, %ebp\n"
                                       `"        pushl   %ecx\n"
                                       `"        subl    $20, %esp\n"
                                       `"        movl    $1024, (%esp)\n"
                                       `"        call    \${_PREFIX}malloc\n"
                                       `"        leal    1024(%eax), %esi\n"
                                       `"        leal    -8(%esi), %ebx\n"

# termination: transfer from internal linkage to return from C linkage

        | 'exit                        `"        addl    $20, %esp\n"
                                       `"        popl    %ecx\n"
                                       `"        popl    %ebp\n"
                                       `"        leal    -4(%ecx), %esp\n"
                                       `"        movl    $0, %eax\n"
                                       `"        ret\n"

# utility function to print an integer

                                       `"print:  popl    -4(%ebx)\n"
                                       `"        movl    %esi, -8(%ebx)\n"
                                       `"        movl    $_S_fmti, (%esp)\n"
                                       `"        movl    (%ebx), %eax\n"
                                       `"        movl    %eax, 4(%esp)\n"
                                       `"        call    \${_PREFIX}printf\n"
                                       `"        movl    -8(%ebx), %esi\n"
                                       `"        pushl   -4(%ebx)\n"
                                       `"        ret\n"
                                       `"        .data\n"
                                       `"_V_print:.long  print\n"
                                       `"_S_fmti:.asciz  \"%d\\n\"\n"
                                       `"        .text\n"

        | .:x                          `(error "unrecognised insn" x)
