# -*- coke -*-

insn	= '( 'label .:l				-> `(printf "L%d:\n" l)
	   | 'save				-> `(printf "\t.save\n")
	   | 'long .:n				-> `(printf "\t.data\n%s:\t.long 0\n\t.text\n" n)
	   | 'load-long .:l			-> `(printf "\t.ldlong\t%d\n" l)
	   | 'load-arg  .:n			-> `(printf "\t.arg\t%d\n" n)
	   | 'load-var  .:n			-> `(printf "\t.var\t%s\n" n)
	   | 'load-label .:n			-> `(printf "\t.ldlabel\tL%d\n" n)
	   | 'store-var .:n			-> `(printf "\t.stvar\t%s\n" n)
	   | 'add				-> `(printf "\t.add\t\n")
	   | 'sub				-> `(printf "\t.sub\t\n")
	   | 'less				-> `(printf "\t.lt\t\n")
	   | 'branch-false .:l			-> `(printf "\t.bf\tL%d\n" l)
	   | 'branch .:l			-> `(printf "\t.br\tL%d\n" l)
	   | 'labeled '(.*) insn*
	   | 'call .:n				-> `(printf "\t.call\t%d\n" n)
	   | 'enter				-> `(printf "\t.enter\n")
	   | 'leave				-> `(printf "\t.leave\n")
	   | 'main				-> `(printf "\t.main\n")
	   | 'exit				-> `(printf "\t.exit\n")
	   | .:x				-> `(error "unrecognised insn" x)
	   )

start	= '( insn* )
